# Python script used to convert IAR headers into GCC usualable headers.

def bits(data):
    '#define FIO0MASK         VOLATILE_BITS(FIO0MASK, 0x3FFFC010, __fgpio0_bits)'
    print
    for l in data:
        if 'VOLATILE32' in l:
            d = l.split()
            d[2] = d[2].replace('VOLATILE32(','').replace(')','')
            if len(d) == 5:
                n = "%s %s         VOLATILE_BITS(%s, %s, %s\n" % (
                                d[0], d[1], d[1], d[2], d[4])
                new.append(n)
            else:
                new.append(l)
        else:
            new.append(l)

    open('D:/Dev_UW/Dev/LPC2378STK_gcc/bsp/iolpc2378_a.h','w').write(''.join(new))

def vtypes():
    # from:
    #define PINSEL0                VOLATILE_BITS(PINSEL0, 0xE002C000, __pinsel0_bits)
    
    # ['#define', 'DOW', 'DOW', '0xE0024030', '__dow_bits']
    
    # to:
    #define SSS 		VOLATILE32(0xE0068000)
    #define SSS_bit 	VOLATILE_TYPE(0xE0068000, __sspcr0_bits)
    
    data = open('C:/Dev_UW/LCD_Demo_2478/inc/iolpc2470.h','r').readlines()
    new = []
    print len(data)
    print
    
    for l in data:
        if 'VOLATILE_BITS' in l:
            l = l.replace('VOLATILE_BITS(','').replace(')','').replace(',','')
            d = l.split()
            #print d
            n = "#define %s         VOLATILE32(%s)\n" % (d[1], d[3])
            new.append(n)
            n = "#define %s_bit     VOLATILE_TYPE(%s, %s)\n" % (d[1], d[3], d[4])
            new.append(n)
        else:
            new.append(l)

    open('C:/Dev_UW/LCD_Demo_2478/inc/iolpc2470_gcc.h','w').write(''.join(new))

def change_io_reg32_bit():
    # FROM:
    #   __IO_REG32_BIT(MEMMAP,                0xE01FC040,__READ_WRITE ,__memmap_bits);
    #
    # TO:
    #   define SSS 		VOLATILE32(0xE0068000)
    #   define SSS_bit 	VOLATILE_TYPE(0xE0068000, __sspcr0_bits)
    #
    # FROM:
    #   __IO_REG8_BIT( USBDEVINTPRI,          0xFFE0C22C,__WRITE      ,__usbdevintpri_bits);
    #
    # TO:
    #   define SSS 		VOLATILE8(0xE0068000)
    #   define SSS_bit 	VOLATILE_TYPE(0xE0068000, __sspcr0_bits)
    #
    # FROM:
    #   __IO_REG32(    VICVECTADDR0,          0xFFFFF100,__READ_WRITE);
    #
    # TO:
    #   #define VICVECTADDR0           VOLATILE32(0xFFFFF100)
    #     
    
    # FROM:
    #   __IO_REG16(    S0SPDR,                0xE0020008,__READ_WRITE);
    #
    # TO:
    #   #define VICVECTADDR0           VOLATILE16(0xFFFFF100)
    #
    
    # FROM:
    #   __IO_REG8(     U0SCR,                 0xE000C01C,__READ_WRITE);
    #
    # TO:
    #   #define VICVECTADDR0           VOLATILE8(0xFFFFF100)
    #
    
    # REQUIRES to be added to header file:
    #
    #   #define VOLATILE32(addr) (*(volatile uint32_t *)(addr))
    #   #define VOLATILE16(addr) (*(volatile uint16_t *)(addr))
    #   #define VOLATILE8(addr)  (*(volatile uint8_t *)(addr))
    #
    src = 'C:/Dev_UW/LCD_Demo_2478/inc/iolpc2470.h'
    dst = 'C:/Dev_UW/LCD_Demo_2478/inc/iolpc2470_gcc.h'
    
    data = open(src,'r').readlines()
    new = ['#define VOLATILE32(addr) (*(volatile uint32_t *)(addr))\n',
           '#define VOLATILE16(addr) (*(volatile uint16_t *)(addr))\n',
           '#define VOLATILE8(addr)  (*(volatile uint8_t *)(addr))\n\n']

    print 'Number of lines:', len(data)
    print
    
    try:
        for l in data:
            if '__IO_REG32_BIT' in l:
                l = l.replace('__IO_REG32_BIT(',' ').replace(')',' ').replace(',',' ')
                d = l.split()
                #print d
                n = "#define %s         VOLATILE32(%s)\n" % (d[0], d[1])
                new.append(n)
                if len(d) > 3:
                    n = "#define %s_bit     VOLATILE_TYPE(%s, %s)\n" % (d[0], d[1], d[3])
                    new.append(n)
            elif '__IO_REG8_BIT' in l:
                l = l.replace('__IO_REG8_BIT(',' ').replace(')',' ').replace(',',' ')
                d = l.split()
                #print d
                n = "#define %s         VOLATILE8(%s)\n" % (d[0], d[1])
                new.append(n)
                if len(d) > 3:
                    n = "#define %s_bit     VOLATILE_TYPE(%s, %s)\n" % (d[0], d[1], d[3])
                    new.append(n)
            elif '__IO_REG32' in l:
                l = l.replace('__IO_REG32(','').replace(');','').replace(',',' ')
                d = l.split()
                n = "#define %s         VOLATILE32(%s)\n" % (d[0], d[1])
                new.append(n)                
            elif '__IO_REG16' in l:
                l = l.replace('__IO_REG16(','').replace(');','').replace(',',' ')
                d = l.split()
                n = "#define %s         VOLATILE16(%s)\n" % (d[0], d[1])
                new.append(n)                
            elif '__IO_REG8' in l:
                l = l.replace('__IO_REG8(','').replace(');','').replace(',',' ')
                d = l.split()
                n = "#define %s         VOLATILE8(%s)\n" % (d[0], d[1])
                new.append(n)                
            else:
                new.append(l)
    except e:
        print e

    open(dst,'w').write(''.join(new))
    
change_io_reg32_bit()