
#define __REG32 unsigned long

typedef struct{
__REG32 DSS  : 4;
__REG32 FRF  : 2;
__REG32 SPO  : 1;
__REG32 SPH  : 1;
__REG32 SCR  : 8;
__REG32      :16;
} __sspcr0_bits;



/*  original
 *
 *
 #define __IO_REG32_BIT(NAME, ADDRESS, ATTRIBUTE, BIT_STRUCT)\
                        volatile __no_init ATTRIBUTE union \
                         {                                 \
                           unsigned long NAME;             \
                           BIT_STRUCT NAME ## _bit;      \
                         } @ ADDRESS

 *
 * __IO_REG32_BIT(SSP0CR0,               0xE0068000,__READ_WRITE ,__sspcr0_bits);
 *
 */


#define BIT(a)  (1<<a)

#define VOLATILE32(addr) (*(volatile unsigned int *)(addr))
#define VOLATILE16(addr) (*(volatile uint16_t *)(addr))
#define VOLATILE8(addr)  (*(volatile uint8_t *)(addr))

#define PUTC(c)     while(!(VOLATILE32(U0LSR) & ULSR_THRE)) continue; \
	                       VOLATILE32(U0THR) = (uint8_t) c

/*
#define VOLATILE_BITS(NAME, ADDR, BIT_STRUCT) \
                        volatile union \
                         {                               \
                           unsigned long NAME;           \
                           BIT_STRUCT NAME ## _bit;      \
                         } *U_ ## NAME;                  \
                         (*(U_ ## NAME *)(ADDR))
// *(ADDR)
*/

typedef volatile union
{
	unsigned long ss;
	__sspcr0_bits ss_bit;
 } foo;

void test(void)
{
	foo ff;
	foo *ss;

	ss = (foo *)(0xE0068000);

	ff.ss = 1;

	ss->ss_bit.DSS = 1;
	ss->ss = 1;
}

void test2(void)
{
	union bar
	{
		unsigned long ss;
		__sspcr0_bits ss_bit;
	};

	((volatile union bar *)(0xE0068000))->ss = 1;

	((volatile union bar *)(0xE0068000))->ss_bit.DSS = 1;
}

void test2a(void)
{
	// anonymous union does not
	// define its members in the scope
//	union
//	{
//		unsigned long ss;
//		__sspcr0_bits ss_bit;
//	};

	// So this doesn't work:
	//ss = 1;

}

void test3(void)
{
	((volatile union { unsigned long ss; __sspcr0_bits ss_bit;} *)(0xE0068000))->ss = 1;
}


#define __IO_REG32_BIT(NAME, ADDRESS, ATTRIBUTE, BIT_STRUCT)\
						((volatile union					\
						  { 								\
							unsigned long NAME;				\
							BIT_STRUCT NAME ## _bit;		\
						  } *)(ADDRESS))

// __IO_REG32_BIT(SSP0CR0, 0xE0068000,__READ_WRITE ,__sspcr0_bits);


#define VOLATILE_BITS(NAME, ADDR, BIT_STRUCT)			\
						((volatile union { 				\
							unsigned long _long;	\
							BIT_STRUCT NAME ## _bit;	\
							} *)(ADDR))

#define SS VOLATILE_BITS(SS, 0xE0068000, __sspcr0_bits)


void test4(void)
{
	SS->_long = 1;
	SS->SS_bit.DSS = 1;

	SS->_long = 1;
}

#define VOLATILE_BITS_2(NAME, ADDR, BIT_STRUCT)			\
						((volatile union { 				\
							unsigned long _long;	\
							BIT_STRUCT NAME ## _bit;	\
							} *)(ADDR))


#define VOLATILE_TYPE(addr, type_name) (*(volatile type_name *)(addr))


#define SSS 		VOLATILE32(0xE0068000)
#define SSS_bit 	VOLATILE_TYPE(0xE0068000, __sspcr0_bits)

void test5(void)
{
	SSS = 1;
	SSS_bit.DSS = 1;
}



